%% Curriculum Vitae style file
%% Rob J Hyndman. Last updated 6 September 2016
%% This file may be modified, copied and redistributed without any further permission.
%% However, if you modify it, please add a note indicating it is a modification of the original.
%% The original file is available at http://robjhyndman.com/research/cv.sty

\usepackage{paralist,ragged2e,datetime}
\usepackage[hyphens]{url}
\usepackage{fancyhdr,enumitem,xcolor,pifont,etoolbox,tikz}
\usepackage[a4paper,text={17.5cm,25.5cm},centering,headsep=.2in]{geometry}
\usepackage[compact,small,sf,bf]{titlesec}
\usepackage{kpfonts,dsfont}
\usepackage{array}
% Define ragged right columns within tables
\newcolumntype{P}[1]{>{\raggedright\arraybackslash}p{#1}}

% Color of headings
\def\headcolor{\color[rgb]{0.6,0,0}}
%\renewcommand\fbox{\fcolorbox{red}{white}}
% define background header color in the all pages
\definecolor{Nbkg}{rgb}{0.21,0.23,0.27}
\pagecolor{gray!20}
% change text color in the header and footer
\patchcmd{\f@nch@head}{\rlap}{\color{white}\rlap}{}{}
\patchcmd{\headrule}{\hrule}{\color{white}\hrule}{}{}
\patchcmd{\f@nch@foot}{\rlap}{\color{green}\rlap}{}{}
\patchcmd{\footrule}{\hrule}{\color{green}\hrule}{}{}

\RaggedRight
\sloppy

% Header and footer
\renewcommand{\headrulewidth}{0pt}
\pagestyle{fancy}
\fancyhead[LE]{%
	\tikz[remember picture,overlay,baseline]
	\fill[Nbkg](current page.north west|-0,-\dp\strutbox)
	rectangle(current page.north east);%
	Resume: \@name}
\fancyhead[LO]{%
	\tikz[remember picture,overlay,baseline]
	\fill[Nbkg](current page.north west|-0,-\dp\strutbox)
	rectangle(current page.north east);%
	Resume: \@name}
\fancyhead[C]{}
\fancyhead[R]{\thepage}
\def\headrule{{\color[gray]{0.4}\hrule\@height\headrulewidth\@width\headwidth \vskip-\headrulewidth}}

% Date format
\newdateformat{rjh}{\monthname~\THEYEAR}
\rjh

% Header box
\def\name#1{\def\@name{#1}}
\def\info#1{\def\@info{#1}}
\newcommand{\shadebox}[3][.9]{\setlength{\fboxrule}{0cm}\colorbox{Nbkg}{\parbox{#2}{#3}}}

\def\maketitle{
	\thispagestyle{plain}
	\vspace*{-2.6cm}
	\hspace*{-2cm}
	\shadebox[0.9]{21cm}{\vspace{2cm}\sf\headcolor\hfil
		\hbox to 16cm{\begin{tabular}{>{\color{white}}P{10cm}}
				\\[-1.7cm]
				\huge\textbf{\@name}\\[0.3cm]
				\Large\textbf{Resume}\\[0.6cm]
				\normalsize\today
			\end{tabular}
			\hfill\hbox{\fontsize{9}{12}\sf
				{\color{white}\begin{tabular}{@{}rP{7.5cm}@{}}
					\@info
		\end{tabular}}}}\hfil
	\vspace{0.3cm}}
	\vspace*{0.2cm}}


% Section headings
\titlelabel{}
\titlespacing{\section}{0pt}{2ex}{1ex}
\titleformat*{\section}{\headcolor\large\sf\bfseries}
\titlespacing{\subsection}{0pt}{1ex}{0.5ex}

% Miscellaneous dimensions
\setlength{\parskip}{0ex}
\setlength{\parindent}{0em}
\setlength{\headheight}{15pt}
\setlength{\tabcolsep}{0.15cm}
\clubpenalty = 10000
\widowpenalty = 10000
\setlist{itemsep=1pt}
\setdescription{labelwidth=1.2cm,leftmargin=1.5cm,labelindent=1.5cm,font=\rm}

% Bibliography formatting

\usepackage[sorting=ydnt,citestyle=authoryear,bibstyle=authoryear-comp,defernumbers=true,maxnames=20,giveninits=true, bibencoding=utf8, terseinits=true, uniquename=init,dashed=false,doi=false,isbn=false,natbib=true,backend=biber]{biblatex}

\DeclareFieldFormat{url}{\url{#1}}
\DeclareFieldFormat[article]{pages}{#1}
\DeclareFieldFormat[inproceedings]{pages}{\lowercase{pp.}#1}
\DeclareFieldFormat[incollection]{pages}{\lowercase{pp.}#1}
\DeclareFieldFormat[article]{volume}{\mkbibbold{#1}}
\DeclareFieldFormat[article]{number}{\mkbibparens{#1}}
\DeclareFieldFormat[article]{title}{\MakeCapital{#1}}
\DeclareFieldFormat[article]{url}{}
\DeclareFieldFormat[inproceedings]{title}{#1}
\DeclareFieldFormat{shorthandwidth}{#1}
\DeclareFieldFormat{extradate}{}
\DeclareFieldFormat[misc]{note}{\mkbibbold{#1}}

% No dot before number of articles
\usepackage{xpatch}
\xpatchbibmacro{volume+number+eid}{\setunit*{\adddot}}{}{}{}

% Remove In: for an article.
\renewbibmacro{in:}{%
	\ifentrytype{article}{}{%
		\printtext{\bibstring{in}\intitlepunct}}}

%\makeatletter
%\DeclareDelimFormat[cbx@textcite]{nameyeardelim}{\addspace}
%\makeatother

% Bibliography categories
\def\makebibcategory#1#2{\DeclareBibliographyCategory{#1}\defbibheading{#1}{\section*{#2}}}
\makebibcategory{books}{Books}
\makebibcategory{papers}{Refereed research papers}
\makebibcategory{chapters}{Book chapters}
\makebibcategory{conferences}{Papers in refereed conference proceedings}
\makebibcategory{techreports}{Unpublished working papers}
\makebibcategory{bookreviews}{Book reviews}
\makebibcategory{editorials}{Editorials}
\makebibcategory{phd}{PhD thesis}
\makebibcategory{subpapers}{Submitted papers}
\makebibcategory{curpapers}{Current projects}
\makebibcategory{software}{Software (R packages)}
\makebibcategory{patents}{Patents}

\setlength{\bibitemsep}{2.3pt}
\setlength{\bibhang}{.9cm}
%\renewcommand{\bibfont}{\fontsize{12}{14}}

\renewcommand*{\bibitem}{\addtocounter{papers}{1}\item \mbox{}\hskip-0.9cm\hbox to 0.9cm{\hfill\arabic{papers}.~\,}}
\defbibenvironment{bibliography}
{\list{}
	{\setlength{\leftmargin}{\bibhang}%
		\setlength{\itemsep}{\bibitemsep}%
		\setlength{\parsep}{\bibparsep}}}
{\endlist}
{\bibitem}

\newenvironment{publications}{\section{\LARGE Publications}\label{papersstart}\vspace*{0.2cm}
	\titlespacing{\section}{0pt}{1.5ex}{1ex}\itemsep=0.00cm
}{\label{papersend}\addtocounter{sumpapers}{-1}\refstepcounter{sumpapers}\label{sumpapers}}

\def\printbib#1{\printbibliography[category=#1,heading=#1]\lastref{sumpapers}}
\renewcommand{\bibfont}{\normalfont\fontsize{10}{12.4}\rmfamily}
% Counters for keeping track of papers
\newcounter{papers}\setcounter{papers}{0}
\newcounter{sumpapers}\setcounter{sumpapers}{0}
\def\lastref#1{\addtocounter{#1}{\value{papers}}\setcounter{papers}{0}}

% Add all papers in the bib file.
\nocite{*}

% Make nicer bullets

\renewcommand{\labelitemi}{\ding{228}}

\DeclareSortingTemplate{ty}{
	\sort{
		\field{title}
	}
	\sort{
		\field{year}
	}
}
